topic "AsyncQueue";
[2 $$0,0#00000000000000000000000000000000:Default]
[i448;a25;kKO9;2 $$1,0#37138531426314131252341829483380:class]
[l288;2 $$2,2#27521748481378242620020725143825:desc]
[0 $$3,0#96390100711032703541132217272105:end]
[H6;0 $$4,0#05600065144404261032431302351956:begin]
[i448;a25;kKO9;2 $$5,0#37138531426314131252341829483370:item]
[l288;a4;*@5;1 $$6,6#70004532496200323422659154056402:requirement]
[l288;i1121;b17;O9;~~~.1408;2 $$7,0#10431211400427159095818037425705:param]
[i448;b42;O9;2 $$8,8#61672508125594000341940100500538:tparam]
[b42;2 $$9,9#13035079074754324216151401829390:normal]
[{_} 
[ {{10000@(113.42.0) [s0;%% [*@7;4 AsyncQueue]]}}&]
[s0; &]
[s1;:Upp`:`:AsyncQueue`:`:class: [@(0.0.255)3 class][3 _][*3 AsyncQueue][3 _:_][@(0.0.255)3 priv
ate][3 _][*@3;3 Moveable][3 <][*3 AsyncQueue][3 >_]&]
[s2;#%% This helper base class provides through a standardized interface 
a simple yet flexible asynchronous model for writing components 
utilizing non`-blocking operations in a single`-threaded environment. 
AsyncQueue class uses a very simple, programmable,  job/queue 
model.&]
[s3; &]
[ {{10000F(128)G(128)@1 [s0;%% [* Protected Method List]]}}&]
[s4; &]
[s5;:Upp`:`:AsyncQueue`:`:AddJob`(`): [_^Upp`:`:Callback^ Callback][@(0.0.255) `&]_[* AddJo
b]()&]
[s2;%% Adds an vacant job to the job queue. Returns a reference to 
the vacant job.&]
[s3; &]
[s4; &]
[s5;:Upp`:`:AsyncQueue`:`:AddJob`(Upp`:`:Callback`): [_^Upp`:`:AsyncQueue^ AsyncQueue][@(0.0.255) `&
]_[* AddJob]([_^topic`:`/`/Core`/src`/Callbacks`$en`-us`#Callback`:`:class^ Callback]_
[*@3 cb])&]
[s2;%% Adds the job [%-*@3 cb] to the job queue. Returns `*this for 
method chaining.&]
[s3;%% &]
[s4; &]
[s5;:Upp`:`:AsyncQueue`:`:InsertJob`(int`): [_^Upp`:`:Callback^ Callback][@(0.0.255) `&]_
[* InsertJob]([@(0.0.255) int]_[*@3 i])&]
[s2;%% Inserts a vacant job to the job queue, at position [%-*@3 i]. 
Returns a reference to the vacant job.&]
[s3;%% &]
[s4; &]
[s5;:Upp`:`:AsyncQueue`:`:InsertJob`(int`,Upp`:`:Callback`): [_^Upp`:`:AsyncQueue^ Asyn
cQueue][@(0.0.255) `&]_[* InsertJob]([@(0.0.255) int]_[*@3 i], [_^topic`:`/`/Core`/src`/Callbacks`$en`-us`#Callback`:`:class^ C
allback]_[*@3 cb])&]
[s2;%% Inserts job [%-*@3 cb] to the job queue, at position [%-*@3 i]. 
Returns `*this for method chaining.&]
[s3;%% &]
[s4; &]
[s5;:Upp`:`:AsyncQueue`:`:GetJob`(int`): [_^Upp`:`:Callback^ Callback][@(0.0.255) `&]_[* Ge
tJob]([@(0.0.255) int]_[*@3 i])&]
[s2;%% Returns a reference to the job at position [%-*@3 i].&]
[s3;%% &]
[s4; &]
[s5;:Upp`:`:AsyncQueue`:`:RemoveJob`(int`): [@(0.0.255) void]_[* RemoveJob]([@(0.0.255) int
]_[*@3 i])&]
[s2;%% Removes a job at position [%-*@3 i ]from the job queue. Note 
that this operation invalidates references to job queue.&]
[s3;%% &]
[s4; &]
[s5;:Upp`:`:AsyncQueue`:`:ProcessQueue`(`): [@(0.0.255) void]_[* ProcessQueue]()&]
[s2;%% Removes the current/completed job from the queue, and starts 
the next job if any. This method must be invoked when a job is 
successfully done.&]
[s3; &]
[s4; &]
[s5;:Upp`:`:AsyncQueue`:`:ClearQueue`(`): [@(0.0.255) void]_[* ClearQueue]()&]
[s2;%% Clears the job queue and the error flag.&]
[s3; &]
[s4; &]
[s5;:Upp`:`:AsyncQueue`:`:QueueHasJobs`(`)const: [@(0.0.255) bool]_[* QueueHasJobs]()_[@(0.0.255) c
onst]&]
[s2;%% Returns true if there are pending jobs in the queue, excluding 
current job in progress.&]
[s3; &]
[s4; &]
[s5;:Upp`:`:AsyncQueue`:`:QueueIsHalted`(`)const: [@(0.0.255) bool]_[* QueueIsHalted]()_[@(0.0.255) c
onst]&]
[s2;%% Checks whether the queue is cancelled due to a fatal error.&]
[s3; &]
[s4; &]
[s5;:Upp`:`:AsyncQueue`:`:QueueIsEmpty`(`)const: [@(0.0.255) bool]_[* QueueIsEmpty]()_[@(0.0.255) c
onst]&]
[s2;%% Returns true if the job queue is empty.&]
[s3; &]
[s4; &]
[s5;:Upp`:`:AsyncQueue`:`:GetJobCount`(`)const: [@(0.0.255) int]_[* GetJobCount]()_[@(0.0.255) c
onst]&]
[s2;%% Returns the number of pending jobs in job queue, including 
the the job in progress.&]
[s3; &]
[s4; &]
[s5;:Upp`:`:AsyncQueue`:`:Halt`(`): [@(0.0.255) void]_[* Halt]()&]
[s2;%% Halts any job in progress, and cancels the job queue. This 
method should be invoked when a fatal error is occured.&]
[s3; &]
[ {{10000F(128)G(128)@1 [s0;%% [* Public Method List]]}}&]
[s0; &]
[s5;:Upp`:`:AsyncQueue`:`:Do`(`): [@(0.0.255) virtual] [@(0.0.255) bool]_[* Do]()&]
[s2;%% Progresses the job queue by executing the pending jobs. Returns 
true if processing is not finished. This method can be overridden. 
&]
[s3; &]
[s4; &]
[s5;:Upp`:`:AsyncQueue`:`:InProgress`(`)const: [@(0.0.255) bool]_[* InProgress]()_[@(0.0.255) c
onst]&]
[s2;%% Returns true if an operation (a job or set of jobs) is in 
progress.&]
[s3; &]
[s4; &]
[s5;:Upp`:`:AsyncQueue`:`:IsSuccess`(`)const: [@(0.0.255) bool]_[* IsSuccess]()_[@(0.0.255) c
onst]&]
[s2;%% Returns true if an operation (a job or set of jobs) is completed 
successfully.&]
[s3; &]
[s4; &]
[s5;:Upp`:`:AsyncQueue`:`:IsFailure`(`)const: [@(0.0.255) bool]_[* IsFailure]()_[@(0.0.255) c
onst]&]
[s2;%% Returns true if an operation (a job or set of jobs) has failed.&]
[s3; &]
[s4; &]
[s5;:Upp`:`:AsyncQueue`:`:WhenDo: [_^Upp`:`:Callback^ Callback]_[* WhenDo]&]
[s2;%% Invoked each time [^topic`:`/`/AsyncQueue`/src`/AsyncQueue`_ABC`$en`-us`#Upp`:`:AsyncQueue`:`:Do`(`)^ D
o()] method exits. Useful for updating GUI, etc.&]
[s3; &]
[ {{10000F(128)G(128)@1 [s0;%% [* Constructor detail]]}}&]
[s0; &]
[s5;:Upp`:`:AsyncQueue`:`:AsyncQueue`(`): [* AsyncQueue]()&]
[s2;%% Default constructor.]]